/* -*- Javascript -*- */

/* global variables */
var period = 0;
var repeat = false;

/* object type*/

/* ... */

/* get/set period */

function set_period () {
  var ref = document.getElementById ('period');
  if (ref)
    ref.value = period;
}

function get_period () {
  var ref = document.getElementById ('period');
  if ((ref) && (ref.value.match (/^[0-9][0-9]*$/)))
    period = ref.value;
}

/* import procedure */

function import_proc (data) {

  var ref = document.getElementById ('display');
  if (!ref) return;

  /* check type */
  var image = ''
  if (escape (data.substr (1, 3)) == 'PNG') image = 'png';
  if (escape (data.substr (6, 4)) == 'JFIF') image = 'jpeg';
  if (escape (data.substr (0, 5)) == 'GIF89') image = 'ǵif';
  if (escape (data.substr (0, 2)) == 'BM') image = 'bmp';

  if (image != '') {
    var ref_img = document.getElementById ('display_img');
    if (!ref_img) {
      ref_img = document.createElement ('img');
      ref_img.id = 'display_img';
      ref_img.className = 'img';
      ref.appendChild (ref_img);
    }
    ref_img.src = 'data:image/' + image + ';base64,' + base64_encode (data);
  } else
    ref.innerHTML = '<pre>' + data.replace (/&/g, "&amp;").replace (/</g, "&lt;").replace (/>/g, "&gt;") + '</pre>';

}

function proc (way) {

  /* start or stop process */
  switch (way) {
  case 'start':
  default:
    if (!repeat) {
      repeat = true;

      ref = document.getElementById ('start');
      if (ref) ref.disabled = true;

      ref = document.getElementById ('stop');
      if (ref) ref.disabled = false;

      refresh ();
    }
    break;

  case 'stop':
    repeat = false;

    ref = document.getElementById ('start');
    if (ref) ref.disabled = false;

    ref = document.getElementById ('stop');
    if (ref) ref.disabled = true;

    break;
  }

}

/* repeatitive action */

function refresh () {

  if (!repeat) return;
  if (last_action != '') {
    proc ('stop');
    return;
  }

  last_action = 'refresh';

  get_period ();
  setTimeout (refresh, period * 1000);

  /* update status */
  update_status ('doing action', 0);

  /* create request message */
  var params = 'action=apply';
  var rxfunc = function (message) {
    var stat = message.getElementsByTagName ('stat')[0].firstChild.nodeValue;
    var data = message.getElementsByTagName ('data')
    if (data && (data.length > 0)) {
      data = data[0].firstChild.nodeValue;
      data =  base64_decode (data);
      window.alert (data.replace (/\033\[[0-9]*;[0-9]*m/g, ""));
    }
    last_action = '';
    if (stat == 0) {
      /* update status on success */
      update_status ('action done', 0);

      /* load result file */
      if ((repeat) || (period == 0)) {
        update_status ('loading result file', 0);

        /* create request message */
        var params = 'action=load';
        var rxfunc = function (message) {
          var stat = message.getElementsByTagName ('stat')[0].firstChild.nodeValue;
          last_action = '';
          if (stat == 0) {
            /* process data */
            update_status ('file loaded', 0);
            var data = message.getElementsByTagName ('data')[0].firstChild.nodeValue;
            import_proc (base64_decode (data));
            update_status ('refresh done', 0);
          } else {
            /* update status on error */
            update_status ('error while loading result file (' + stat + ')', 2);
          }
        };

        ajax_post (params, rxfunc);

      }
    } else {
      /* update status on error */
      update_status ('error (' + stat + ')', 2);
      last_action = '';
    }
  };

  ajax_post (params, rxfunc);

  return '';
}
